%***********************************
%   EJERCICIO DEL MOTOR
%   Estimadores de estado
%   Filtro de Kalman
%     CLASE  TEORA
%***********************************
close all;
clear all;
clc;

% VALORES
Ra=2;
La=5e-3;
J=5e-3;
B1=5e-3;
Kt=0.7;
Kw=0.8;
% valores para simulacin
Ae=zeros(3,3);
Be=zeros(3,2);
Ce=zeros(3,3);
De=zeros(3,2);
Xe0=[0;0;0];
A0=10;
Ts=0.001;
K1=0;
K2=0;
K3=0;
Ki=1;
% MATRICES
A=[-Ra/La -Kw/La 0; Kt/J -B1/J 0; 0 1 0];
B=[A0/La; 0; 0];
C=[1 0 0; 0 1 0; 0 0 1];
D=[0; 0; 0];
% MODELO DE ESTADO
disp('Modelo Continuo');
P1=ss(A,B,C,D)
%%
% % SIMULACIN
% T = 0:0.001:0.1;
% [y,T]=step(P1,T);
% % GRFICO VARIABLES DE ESTADO
% plot(T,y(:,1:3));
% grid on;
%%
% Transformacin a Modelo Discreto
clc;
C1=[0 0 1];
D1=0;

P1=ss(A,B,C1,D1);
Ts=0.001;
disp(' ');
disp('Modelo disreto');
P2=c2d(P1,Ts)
disp(' ');
disp('Autovalores');
pole(P2)
Ae=P2.a;
Be=[P2.b,[0;0;0]];
Ce=eye(3);
Xe0=[200;800;100];

%%
clc;
% Modelo Cannico observable
[Num,Den]=tfdata(P2,'v');
disp(' ');
disp('Matrices del Modelo Cannico');
Ac=[0,0,-Den(1,4);1,0,-Den(1,3);0,1,-Den(1,2)]
Cc=[0,0,1]
disp(' ');
disp('Matriz de Transformacin');
V=obsv(P2.a,P2.c);
Vt=obsv(Ac,Cc);
P=V^-1*Vt
disp(' ');
disp('Modelo Cannico');
P3=ss2ss(P2,P^-1)

%%
% Estimador
clc;
% ubico los autovalores del estimador
z1=input('autovalor del estimador z1 = ')
z2=input('autovalor del estimador z2 = ')
z3=input('autovalor del estimador z3 = ')
str1=sprintf('\n Vector del Estimador del Modelo Canonico \n');
disp(str1);
H1=acker(Ac',Cc',[z1,z2,z3])'
str1=sprintf('\n Vector del Estimador del Modelo Original \n');
disp(str1);
H=P*H1

Ae=P2.a-H*P2.c;
eig(Ae);
Be=[P2.b,H];
Ce=eye(3);
Xe0=[10;10;10];

%%
% close all;
% % Modelo del Error
% str1=sprintf('\n Modelo del error \n');
% disp(str1);
% Ve=zeros(3,1); 
% Pe=ss(Ae,Ve,Ce,Ve,Ts)
% initial(Pe,Xe0,1);
% eig(Ae);

%%
